<?
include("header.php");
include("magicfun.php");
$atknames[Standard] = "Standard Attack";
$atknames[Surprise] = "Surprise Attack";
$atknames[armtrp] = "Guerilla Strike";
$atknames[lndtrp] = "Stone Bombardment";
$atknames[flytrp] = "Aerial Assault";
$atknames[seatrp] = "Hydro Assault";

// era of troops, quantity of troops, type of troops, offense or defense
function CalcPoints($era, $quantity, $ttype, $atype)
{
	$type = $atype."_".$ttype;
	return $quantity * $era[$type];
}

function ReadInput ($type)
{
	global $users, $usent, $enemy, $esent, $sendall, $trplst;

	for ($i = 0; $i < 4; $i++)
	{
		$trp = $trplst[$i];
		$esent[$trp] = $enemy[$trp];
		if ($sendall)				// send everything?
			$usent[$trp] = $users[$trp];
	}

	if (($type != 'Standard') && ($type != 'Surprise'))
	{
		for ($i = 0; $i < 4; $i++)
		{
			$trp = $trplst[$i];
			if ($type != $trp)
				$usent[$trp] = $esent[$trp] = 0;
		}
	}
	for ($i = 0; $i < 4; $i++)
		CheckQuantity($trplst[$i]);
}

function CheckQuantity($type)
{
	global $users, $uera, $usent;
	fixInputNum($usent[$type]);
	$esent[$type] = round($esent[$type]);
	if ($usent[$type] < 0)
		TheEnd("Cannot attack with a negative number of units!");
	if ($usent[$type] > $users[$type])
		TheEnd("You do not have that many $uera[$type]!");
}

function Attack($type)
{
	global $users, $urace, $uera, $usent, $enemy, $erace, $eera, $esent, $playerdb, $time, $trplst;
	$uoffense = 0;
	$edefense = 0;
	for ($i = 0; $i < 4; $i++)
	{
		$uoffense += CalcPoints($uera,$usent[$trplst[$i]],$trplst[$i],o);
		$edefense += CalcPoints($eera,$esent[$trplst[$i]],$trplst[$i],d);
	}
	if ($uoffense == 0)
		TheEnd("Must attack with something!");

	$uoffense *= $users[health] / 100;
	$edefense *= $enemy[health] / 100;

	if ($users[era] != $enemy[era])			// only step through time gate if necessary
	{
		if ($users[gate] > $time)		// your time gate?
			print "Stepping through your open time gate,<br>\n";
		elseif ($enemy[gate] > $time)		// or enemy's time gate?
			print "Stepping through your enemy's open time gate,<br>\n";
	}

	if ($type == 'Surprise')			// surprise attack?
	{
		$uoffense *= 1.25;
		$users[health] -= 5;
	}

	$uoffense = round($uoffense * $urace[offense]);
	$edefense = round($edefense * $erace[defense]);

	$tdefense = $enemy[defbld] * 450 * min(1,$enemy[armtrp] / (150*$enemy[defbld]+1));   // and add in towers
	$edefense += $tdefense;
	if ($enemy[networth] == 0)		// if networth is zero (possibly from having deleted self)
		$tdefense = $edefense = 0;	// then they have NO defense :)
	dobattle($uoffense,$edefense,$type,$tdefense);
}

/*
dobattle(Offense_Points, Defense_Points, Attack_Type)
This function:
determines who won
calls detloss() to determine troop losses
calls dealland() if attack was successful
*/
function dobattle ($op, $dp, $type, $towp)
{
	$emod = sqrt($op/($dp+1));		// modification to enemy losses
	$umod = sqrt(($dp-$towp)/($op+1));	// modification to attacker losses (towers not included)
	switch ($type)
	{
	case 'armtrp':
		detloss(.1155, .0705, $umod, $emod, armtrp);
		break;

	case 'lndtrp':
		detloss(.0985, .0530, $umod, $emod, lndtrp);
		break;

	case 'flytrp':
		detloss(.0688, .0445, $umod, $emod, flytrp);
		break;

	case 'seatrp':
		detloss(.0450, .0355, $umod, $emod, seatrp);
		break;

	case 'Surprise':
		$umod *= 1.2;			// fall through

	case 'Standard':
		detloss(.1455, .0805, $umod, $emod, armtrp);
		detloss(.1285, .0730, $umod, $emod, lndtrp);
		detloss(.0788, .0675, $umod, $emod, flytrp);
		detloss(.0650, .0555, $umod, $emod, seatrp);
		break;
	}
	if ($op > $dp * 1.05)
		dealland($type);
	printedreport();
}

/*
This function determines the loss of specific types of troops
It handles the attacker and defender in one run through
*/
function detloss($uper, $eper, $umod, $emod, $type)
{
	global $uloss, $eloss, $usent, $esent;
	if ($usent[$type] > 0)		// can't lose more than you send... send none, lose none
		$uloss[$type] = min(mt_rand(0,(ceil($usent[$type] * $uper * $umod)+1)), $usent[$type]);
	else	$uloss[$type] = 0;

	$maxkill = round(.9*$usent[$type]) + mt_rand(0, round(.2*$usent[$type] + 1)); // max kills determination (90% - 110%)

	if ($esent[$type] > 0)		// he can't lose more than he defended with, or attacker can kill
		$eloss[$type] = min(mt_rand(0,ceil($esent[$type] * $eper * $emod)), $esent[$type], $maxkill);
	else	$eloss[$type] = 0;	// no troops, no losses
}

function LossCalc(&$player, &$ploss)
{
	global $trplst;
	for ($i = 0; $i < 4; $i++)
		$player[$trplst[$i]] -= $ploss[$trplst[$i]];
}

function DealLand($type)
{
	global $landloss, $buildgain, $enemy, $users;

	$landloss = 0;
	$buildgain = 0;

	// destroy structures
	destroyBuildings('popbld',7,70,$type);
	destroyBuildings('cashbld',7,70,$type);
	destroyBuildings('trpbld',7,50,$type);
	destroyBuildings('costbld',7,70,$type);
	destroyBuildings('wizbld',7,60,$type);
	destroyBuildings('foodbld',7,30,$type);
	destroyBuildings('defbld',10.5,60,$type);	// Towers are more likely to be taken because they are getting attacked first
	destroyBuildings('freeland',10,0,$type);	// 3rd argument MUST be 0 (for Standard attacks) - calculate gained freeland below
	$users[freeland] += $landloss - $buildgain;

	// update total land counts
	$users[land] += $landloss;
	$enemy[land] -= $landloss;
}

// To handle destroying buildings during successful attacks
function destroyBuildings ($type, $pcloss, $pcgain, $atktype)
{
	global $landloss, $buildgain, $enemy, $users;
	$pcloss /= 100;
	$pcgain /= 100;

	if (($atktype == 'lndtrp') || ($atktype == 'flytrp') || ($atktype == 'seatrp'))
	{				// these attacks destroy extra buildings, but fewer are gained
		if ($atktype == 'flytrp')
		{
			$pcloss *= 1.25;
			$pcgain *= 0.72;
		}
		elseif (($type == 'defbld') || ($type == 'wizbld'))
		{
			$pcloss *= 1.3;
			$pcgain *= 9/13;
		}
		else	$pcgain *= 0.9;
	}

	$loss = 0;
	if ($enemy[$type] > 0)
		$loss = mt_rand(1,ceil($enemy[$type] * $pcloss + 2));
	if ($loss > $enemy[$type])
		$loss = $enemy[$type];
	$gain = ceil($loss * $pcgain);

	switch ($atktype)
	{
	case 'Standard':
		$enemy[$type] -= $loss;
		$landloss += $loss;
		$users[$type] += $gain;
		$buildgain += $gain;
		break;
	case 'Surprise':
	case 'armtrp':
		$enemy[$type] -= $loss;
		$landloss += $loss;
		break;
	case 'lndtrp':
	case 'flytrp':
	case 'seatrp':
		if ($type == 'freeland')	// for stealing unused land, the 'gain' percent is zero
			$gain = $loss;		// so we need to use the 'loss' value instead
		$enemy[$type] -= $loss;
		$enemy[freeland] += $loss - $gain;
		$landloss += $gain;
		break;
	}
}

function printedreport()
{
	global $users, $uloss, $uera, $enemy, $eloss, $eera, $landloss, $buildgain, $trplst;
	if ($landloss)
	{
		$pts = findScorePoints($users, $enemy);
		print "Your army breaks through $enemy[empire]'s defenses and captures $landloss acres of land! (+$pts pts)<br>In the effort, you lost:<br>\n";
		$users[score] += $pts;
		$enemy[score]--;
	}
	else
	{
		$pts = findScorePoints($users, $enemy) * 0.5;
		print "After a failing struggle, your army is repelled by $enemy[empire]'s defenses. (-$pts pts)<br>In the attempt, you lost:<br>\n";
		$users[score] -= $pts;
		$enemy[score]++;
	}
	for ($i = 0; $i < 4; $i++)
	{
		$trp = $trplst[$i];
		if ($uloss[$trp]) print commas($uloss[$trp])." $uera[$trp]<br>\n";
	}
	print "In their defense, $enemy[empire] lost:<br>\n";
	for ($i = 0; $i < 4; $i++)
	{
		$trp = $trplst[$i];
		if ($eloss[$trp]) print commas($eloss[$trp])." $eera[$trp]<br>\n";
	}
	if ($buildgain)
		print "You also captured $buildgain structures!<br>\n";
	if (($enemy[land] == 0) && (($enemy[disabled] != 4) || ($enemy[idle] > $time - 60*30)))
	{				// if killed within 30 minutes of deletion, still give credit
		$killpts = max($enemy[score] / 5,100);
?><span class="cgood"><b><?=$enemy[empire]?> (#<?=$enemy[num]?>)</b> has been destroyed! (+<?=$killpts?> pts)</span><br>
<?		$users[kills]++;
		$users[score] += $killpts;
		$enemy[killedby] = $users[num];
	}
	elseif ($enemy[land] == 0)
	{?>
<span class="cgood"><b><?=$enemy[empire]?> (#<?=$enemy[num]?>)</b> has no remaining land.</span><br>
<?	}
}

// To print the attack table
function printRow ($type)
{
	global $users, $uera;
?>
<tr><td><?=$uera[$type]?></td>
    <td class="ar"><?=commas($users[$type])?></td>
    <td class="ar"><input type="text" name="usent[<?=$type?>]" size="8" value="0"></td></tr>
<?
}

// *************
// End Functions
// *************

if ($users[turnsused] <= $config[protection])	// are they under protection?
	TheEnd("Cannot use offensive actions while under protection!");
if ($users[disabled] == 2)			// are they admin?
	TheEnd("Administrative accounts cannot use offensive actions!");

if ($do_attack)
{
	if ($users[turns] < 2)						// enough turns?
		TheEnd("Not enough turns!");
	fixInputNum($target);
	if (!$target)							// specified target?
		TheEnd("You must specify a target!");
	if ($target == $users[num])					// attacking self?
		TheEnd("Cannot attack yourself!");
	if ($users[health] <= 10)
		TheEnd("You do not have enough health to attack.");
	$enemy = loadUser($target);
	$erace = loadRace($enemy[race]);
	$eera = loadEra($enemy[era]);					// load enemy info

	if ($enemy[land] == 0)
		TheEnd("That empire has already been destroyed!");
	if (($enemy[era] != $users[era]) && ($users[gate] <= $time) && ($enemy[gate] <= $time))
		TheEnd("Need to open a Time Gate first!");
	if ($enemy[disabled] == 2)
		TheEnd("Cannot attack Administrators!");
	if ($enemy[disabled] == 3)
		TheEnd("Cannot attack disabled empires!");
	if ($enemy[turnsused] <= $config[protection])
		TheEnd("Cannot attack empires under new player protection!");
	if ($enemy[vacation] > $config[vacationdelay])
		TheEnd("Cannot attack empires on vacation!");
	$netmult = 50;

	if ($enemy[disabled] == 4)	// if they've self-deleted, zero their networth
		$enemy[networth] = 0;	// to disable size difference limitations

	if ($enemy[networth] && ($enemy[networth] > $users[networth] * $netmult))
		TheEnd("Your Generals flatly refuse to attack such a strong opponent!");

	readInput($attacktype);

	$revolt = 1;
	if ($enemy[networth] && ($enemy[networth] < $users[networth] / 5))
	{						// Shame is less powerful than fear
?><span class="cwarn">Your military is shamed by your attack on such a weak opponent. Many desert!</span><br>
<?		$revolt = 1 - $users[networth] / $enemy[networth] / 250;
	}
	elseif ($enemy[networth] && ($enemy[networth] > $users[networth] * 5))
	{
?><span class="cwarn">Your military trembles at your attack on such a strong opponent. Many desert!</span><br>
<?		$revolt = 1 - $enemy[networth] / $users[networth] / 200;
	}
	if ($revolt < .9)
		$revolt = .9;
	for ($i = 0; $i < 4; $i++)
	{
		$type = $trplst[$i];
		$users[$type] = round($users[$type] * $revolt);
		if ($usent[$type] > $users[$type])
			$usent[$type] = $users[$type];
	}

	Attack($attacktype);

	// record losses

	losscalc($users, $uloss);
	losscalc($enemy, $eloss);

	if (!$landloss)
		$landloss = 0;
	switch ($attacktype)
	{
	case 'Standard':addNews(302,$users,$enemy,$landloss,$eloss[armtrp],$eloss[lndtrp],$eloss[flytrp],$eloss[seatrp],$uloss[armtrp],$uloss[lndtrp],$uloss[flytrp],$uloss[seatrp]);	break;
	case 'Surprise':addNews(303,$users,$enemy,$landloss,$eloss[armtrp],$eloss[lndtrp],$eloss[flytrp],$eloss[seatrp],$uloss[armtrp],$uloss[lndtrp],$uloss[flytrp],$uloss[seatrp]);	break;
	case 'armtrp':	addNews(304,$users,$enemy,$landloss,$eloss[armtrp],$uloss[armtrp]);	break;
	case 'lndtrp':	addNews(305,$users,$enemy,$landloss,$eloss[lndtrp],$uloss[lndtrp]);	break;
	case 'flytrp':	addNews(306,$users,$enemy,$landloss,$eloss[flytrp],$uloss[flytrp]);	break;
	case 'seatrp':	addNews(307,$users,$enemy,$landloss,$eloss[seatrp],$uloss[seatrp]);	break;
	}
	if ($enemy[killedby] == $users[num])
		addNews(301,$users,$enemy,0);

	$users[offtotal]++;
	$enemy[deftotal]++;
	if ($landloss)
		$users[offsucc]++;
	else	$enemy[defsucc]++;
	$users[health] -= 8;
	saveUserDataNet($users,"networth armtrp lndtrp flytrp seatrp land popbld cashbld trpbld costbld wizbld foodbld defbld freeland offsucc offtotal score health kills");
	saveUserDataNet($enemy,"networth armtrp lndtrp flytrp seatrp land popbld cashbld trpbld costbld wizbld foodbld defbld freeland defsucc deftotal score killedby");

	taketurns(2,'attack');
}
?>
<form method="post" action="<?=$config[main]?>?action=military">
<table class="inputtable">
<tr><td colspan="3" class="ac">Empire number to attack? <input type="text" name="target" value="<?=$target?>" size="5"></td></tr>
<tr><td colspan="3" class="ac">Attack Type: <select name="attacktype">
        <option value="Standard"<?if ($attacktype == "Standard") print " selected";?>><?=$atknames[Standard]?></option>
        <option value="Surprise"<?if ($attacktype == "Surprise") print " selected";?>><?=$atknames[Surprise]?></option>
        <option value="armtrp"<?if ($attacktype == "armtrp") print " selected";?>><?=$atknames[armtrp]?></option>
        <option value="lndtrp"<?if ($attacktype == "lndtrp") print " selected";?>><?=$atknames[lndtrp]?></option>
        <option value="flytrp"<?if ($attacktype == "flytrp") print " selected";?>><?=$atknames[flytrp]?></option>
        <option value="seatrp"<?if ($attacktype == "seatrp") print " selected";?>><?=$atknames[seatrp]?></option>
        </select></td></tr>
<tr><th class="al">Unit</th>
    <th class="ar">Owned</th>
    <th class="ar">Send</th></tr>
<?
for ($i = 0; $i < 4; $i++)
	printRow($trplst[$i]);
?>
<tr><td colspan="3" class="ac"><input type="checkbox" name="sendall" value="1"<?if ($sendall) print " checked";?>>Send Everything</td></tr>
<tr><td colspan="3" class="ac"><input type="submit" name="do_attack" value="Send Attack"></td></tr>
</table>
</form>
<hr>
<form method="post" action="<?=$config[main]?>?action=military">
<table class="inputtable">
<tr><td class="ac">Empire to cast spell on? <input type="text" name="target" value="<?=$target?>" size="5"></td></tr>
<tr><td><select name="spell_num">
        <option value="0">Select a Spell</option>
<?
for ($i = 1; $i <= 12; $i++)
	if ($sptype[$i] == 'o')
		printMRow($i);
?>
        </select></td></tr>
<tr><td class="ac"><input type="submit" name="do_spell" value="Cast Spell"></td></tr>
</table>
</form>
<?
if ($users[shield] > $time)
	print "<i>We currently have a shield against magic which will last for ".round(($users[shield]-$time)/3600,1)." more hours.</i><br>\n";
print "<i>The health of our forces and people is at $users[health]%!</i><br>\n";
if ($users[gate] > $time)
	print "<i>We currently have an open time portal which will last for ".round(($users[gate]-$time)/3600,1)." more hours.</i><br>\n";
TheEnd("");
?>
